'use strict';

var CronogramaFFController = angular.module('CronogramaFFController', []);

CronogramaFFController.controller('CronogramaFFCtrl', ['$scope', 'Construcao', 'CacheApp',
  ($scope, Construcao, CacheApp) => {
      $scope.construcao = {};

      $scope.construcao = CacheApp.getConstrucao();
      $scope.dataInicio = new Date($scope.construcao.DataInicio);
      $scope.dataFim = new Date($scope.construcao.DataFim);

      var tempoRestante = Math.abs($scope.dataFim - $scope.dataInicio);
      $scope.dias = Math.ceil(tempoRestante / (1000 * 3600 * 24));

      $scope.getListaDias = () => {
        $scope.listaDias = [];
        for (var i=0;i<$scope.dias-1;i++) {
            var dia = new Date($scope.construcao.DataInicio);
            dia.setDate(dia.getDate() + i);
            $scope.listaDias.push(dia);
        }
      }


      $scope.getPlanejaEtapa = () => {

        $scope.getListaDias();
        $scope.TotalMedicao = 0;
        $scope.construcao.ValorTotalizadoOrcamento = ($scope.construcao.ValorBDIEncargos == 0
                                                   || $scope.construcao.ValorBDIEncargos == null
                                                   || $scope.construcao.ValorBDIEncargos == undefined)
                                                    ? $scope.construcao.ValorOrcado
                                                    : $scope.construcao.ValorBDIEncargos;

        Construcao.getPlanejaEtapa($scope.construcao.Id,
            (data) => {
                $scope.etapas = data.Instance;
                $scope.Medicoes = [];

                for (var i in $scope.etapas) {
                    var etapa = $scope.etapas[i];
                    var id = etapa.IdEtapa;

                    etapa.QtdDiasInicio = etapa.QtdDiasInicio ? etapa.QtdDiasInicio : 0;;
                    var ini = etapa.QtdDiasInicio;

                    etapa.QtdDiasExecucao = etapa.QtdDiasExecucao ? etapa.QtdDiasExecucao : 0;
                    var fim = etapa.QtdDiasInicio + etapa.QtdDiasExecucao;

                    etapa.DataInicio = new Date($scope.construcao.DataInicio);
                    etapa.DataInicio.setDate(etapa.DataInicio.getDate() + ini);

                    etapa.DataFim = new Date($scope.construcao.DataInicio);
                    etapa.DataFim.setDate(etapa.DataFim.getDate() + fim);

                    for (var j in etapa.Medicoes) {
                        var sliderID = etapa.IdEtapa.toString() + j.toString();
                        var medicao = etapa.Medicoes[j];
                        medicao.SliderID = sliderID;

                        var ini = medicao.QtdDiasInicio;
                        var fim = medicao.QtdDiasInicio + medicao.QtdDiasExecucao;

                        medicao.DataInicio = new Date($scope.construcao.DataInicio);
                        medicao.DataInicio.setDate(medicao.DataInicio.getDate() + ini);
                        medicao.DataFim = new Date($scope.construcao.DataInicio);
                        medicao.DataFim.setDate(medicao.DataFim.getDate() + fim);

                        if ($scope.TotalMedicao < medicao.Medicao)
                            $scope.TotalMedicao = medicao.Medicao;
                    }

                }

                for (var i=1; i<=$scope.TotalMedicao; i++)
                    $scope.Medicoes.push({Medicao: i, Valor: 0});


                for (var i in $scope.etapas) {
                    var etapa = $scope.etapas[i];
                    for (var j in etapa.Medicoes) {
                        var medicao = etapa.Medicoes[j];
                        $scope.Medicoes[medicao.Medicao - 1].Valor += medicao.Valor;
                    }
                }
        });
    }
    $scope.getPlanejaEtapa();


    //   $scope.getConstrucao = function() {
    //     Construcao.getConstrucoes(1, $scope.construcao.Id,
    //         (data) => {
    //             $scope.construcao = {}
    //             $scope.construcao = data.Instance[0];

    //             $scope.getPlanejaEtapa = () => {
    //                 $scope.getListaDias();
    //                 $scope.TotalMedicao = 0;
    //                 $scope.construcao.ValorTotalizadoOrcamento = ($scope.construcao.ValorBDIEncargos == 0
    //                                                            || $scope.construcao.ValorBDIEncargos == null
    //                                                            || $scope.construcao.ValorBDIEncargos == undefined)
    //                                                             ? $scope.construcao.ValorOrcado
    //                                                             : $scope.construcao.ValorBDIEncargos;

    //                 Construcao.getPlanejaEtapa($scope.construcao.Id,
    //                     (data) => {
    //                         $scope.etapas = data.Instance;
    //                         $scope.Medicoes = [];

    //                         for (var i in $scope.etapas) {
    //                             var etapa = $scope.etapas[i];
    //                             var id = etapa.IdEtapa;

    //                             etapa.QtdDiasInicio = etapa.QtdDiasInicio ? etapa.QtdDiasInicio : 0;;
    //                             var ini = etapa.QtdDiasInicio;

    //                             etapa.QtdDiasExecucao = etapa.QtdDiasExecucao ? etapa.QtdDiasExecucao : 0;
    //                             var fim = etapa.QtdDiasInicio + etapa.QtdDiasExecucao;

    //                             etapa.DataInicio = new Date($scope.construcao.DataInicio);
    //                             etapa.DataInicio.setDate(etapa.DataInicio.getDate() + ini);

    //                             etapa.DataFim = new Date($scope.construcao.DataInicio);
    //                             etapa.DataFim.setDate(etapa.DataFim.getDate() + fim);

    //                             for (var j in etapa.Medicoes) {
    //                                 var sliderID = etapa.IdEtapa.toString() + j.toString();
    //                                 var medicao = etapa.Medicoes[j];
    //                                 medicao.SliderID = sliderID;

    //                                 var ini = medicao.QtdDiasInicio;
    //                                 var fim = medicao.QtdDiasInicio + medicao.QtdDiasExecucao;

    //                                 medicao.DataInicio = new Date($scope.construcao.DataInicio);
    //                                 medicao.DataInicio.setDate(medicao.DataInicio.getDate() + ini);
    //                                 medicao.DataFim = new Date($scope.construcao.DataInicio);
    //                                 medicao.DataFim.setDate(medicao.DataFim.getDate() + fim);

    //                                 if ($scope.TotalMedicao < medicao.Medicao)
    //                                     $scope.TotalMedicao = medicao.Medicao;
    //                             }

    //                         }

    //                         for (var i=1; i<=$scope.TotalMedicao; i++)
    //                             $scope.Medicoes.push({Medicao: i, Valor: 0});


    //                         for (var i in $scope.etapas) {
    //                             var etapa = $scope.etapas[i];
    //                             for (var j in etapa.Medicoes) {
    //                                 var medicao = etapa.Medicoes[j];
    //                                 $scope.Medicoes[medicao.Medicao - 1].Valor += medicao.Valor;
    //                             }
    //                         }
    //                 });
    //             }
    //             $scope.getPlanejaEtapa();
    //     });
    //   }
    //   $scope.getConstrucao();

  }]);
